Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.web.servlet.view.document
Class AbstractPdfView

    java.lang.Object
      org.springframework.context.support.ApplicationObjectSupport
          org.springframework.web.context.support.WebApplicationObjectSupport
              org.springframework.web.servlet.view.AbstractView
                  org.springframework.web.servlet.view.document.AbstractPdfView

All Implemented Interfaces:
  Aware, BeanNameAware, ApplicationContextAware, ServletContextAware, View

    public abstract class AbstractPdfView

extends AbstractView

Abstract superclass for PDF views, using Bruno Lowagie's iText package. Application-specific view classes will extend this class. The view will be held in the subclass itself, not in a template.

Note: Internet Explorer requires a ".pdf" extension, as it doesn't always respect the declared content type.

Author:
  Rod Johnson, Juergen Hoeller, Jean-Pierre Pawlak
See Also:
  `AbstractPdfStamperView`

Field Summary

Fields inherited from class org.springframework.web.servlet.view.AbstractView
`DEFAULT_CONTENT_TYPE`

Fields inherited from class org.springframework.context.support.ApplicationObjectSupport
`logger`

Fields inherited from interface org.springframework.web.servlet.View
`PATH_VARIABLES, RESPONSE_STATUS_ATTRIBUTE`

Constructor Summary
`AbstractPdfView()` This constructor sets the appropriate content type "application/pdf".

Method Summary
`protected abstract void` | `buildPdfDocument(java.util.Map<java.lang.String,java.lang.Object> model, com.lowagie.text.Document document, com.lowagie.text.pdf.PdfWriter writer, javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)` Subclasses must implement this method to build an iText PDF document, given the model.
`protected void` | `buildPdfMetadata(java.util.Map<java.lang.String,java.lang.Object> model, com.lowagie.text.Document document, javax.servlet.http.HttpServletRequest request)` Populate the iText Document's meta fields (author, title, etc.).
`protected boolean` | `generatesDownloadContent()` Return whether this view generates download content (typically binary content like PDF or Excel files).
`protected int` | `getViewerPreferences()` Return the viewer preferences for the PDF file.
`protected com.lowagie.text.Document` | `newDocument()` Create a new document to hold the PDF contents.
`protected com.lowagie.text.pdf.PdfWriter` | `newWriter(com.lowagie.text.Document document, java.io.OutputStream os)` Create a new PdfWriter for the given iText Document.
`protected void` | `prepareWriter(java.util.Map<java.lang.String,java.lang.Object> model, com.lowagie.text.pdf.PdfWriter writer, javax.servlet.http.HttpServletRequest request)` Prepare the given PdfWriter.
`protected void` | `renderMergedOutputModel(java.util.Map<java.lang.String,java.lang.Object> model, javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)` Subclasses must implement this method to actually render the view.

Methods inherited from class org.springframework.web.servlet.view.AbstractView
`addStaticAttribute, createMergedOutputModel, createRequestContext, createTemporaryOutputStream, exposeModelAsRequestAttributes, getAttributesMap, getBeanName, getContentType, getRequestContextAttribute, getStaticAttributes, isExposePathVariables, prepareResponse, render, setAttributes, setAttributesCSV, setAttributesMap, setBeanName, setContentType, setExposePathVariables, setRequestContextAttribute, toString, writeToResponse`

Methods inherited from class org.springframework.web.context.support.WebApplicationObjectSupport
`getServletContext, getTempDir, getWebApplicationContext, initApplicationContext, initServletContext, isContextRequired, setServletContext`

Methods inherited from class org.springframework.context.support.ApplicationObjectSupport
`getApplicationContext, getMessageSourceAccessor, initApplicationContext, requiredContextClass, setApplicationContext`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### AbstractPdfView

    public AbstractPdfView()

  This constructor sets the appropriate content type "application/pdf". Note that IE won't take much notice of this, but there's not a lot we can do about this. Generated documents should have a ".pdf" extension.

Method Detail

### generatesDownloadContent

    protected boolean generatesDownloadContent()

  Description copied from class: `AbstractView`
  Return whether this view generates download content (typically binary content like PDF or Excel files).

  The default implementation returns `false`. Subclasses are encouraged to return `true` here if they know that they are generating download content that requires temporary caching on the client side, typically via the response OutputStream.

  Overrides:
    `generatesDownloadContent` in class `AbstractView`
  See Also:
    `AbstractView.prepareResponse(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)`, `ServletResponse.getOutputStream()`

### renderMergedOutputModel

    protected final void renderMergedOutputModel(java.util.Map<java.lang.String,java.lang.Object> model,
                                                 javax.servlet.http.HttpServletRequest request,
                                                 javax.servlet.http.HttpServletResponse response)
                                          throws java.lang.Exception

  Description copied from class: `AbstractView`
  Subclasses must implement this method to actually render the view.

  The first step will be preparing the request: In the JSP case, this would mean setting model objects as request attributes. The second step will be the actual rendering of the view, for example including the JSP via a RequestDispatcher.

  Specified by:
    `renderMergedOutputModel` in class `AbstractView`
  Parameters:
    `model` - combined output Map (never `null`), with dynamic values taking precedence over static attributes
    `request` - current HTTP request
    `response` - current HTTP response
  Throws:
    `java.lang.Exception` - if rendering failed

### newDocument

    protected com.lowagie.text.Document newDocument()

  Create a new document to hold the PDF contents.

  By default returns an A4 document, but the subclass can specify any Document, possibly parameterized via bean properties defined on the View.

  Returns:
    the newly created iText Document instance
  See Also:
    `Document.Document(com.lowagie.text.Rectangle)`

### newWriter

    protected com.lowagie.text.pdf.PdfWriter newWriter(com.lowagie.text.Document document,
                                                       java.io.OutputStream os)
                                                throws com.lowagie.text.DocumentException

  Create a new PdfWriter for the given iText Document.

  Parameters:
    `document` - the iText Document to create a writer for
    `os` - the OutputStream to write to
  Returns:
    the PdfWriter instance to use
  Throws:
    `com.lowagie.text.DocumentException` - if thrown during writer creation

### prepareWriter

    protected void prepareWriter(java.util.Map<java.lang.String,java.lang.Object> model,
                                 com.lowagie.text.pdf.PdfWriter writer,
                                 javax.servlet.http.HttpServletRequest request)
                          throws com.lowagie.text.DocumentException

  Prepare the given PdfWriter. Called before building the PDF document, that is, before the call to `Document.open()`.

  Useful for registering a page event listener, for example. The default implementation sets the viewer preferences as returned by this class's `getViewerPreferences()` method.

  Parameters:
    `model` - the model, in case meta information must be populated from it
    `writer` - the PdfWriter to prepare
    `request` - in case we need locale etc. Shouldn't look at attributes.
  Throws:
    `com.lowagie.text.DocumentException` - if thrown during writer preparation
  See Also:
    `Document.open()`, `PdfWriter.setPageEvent(com.lowagie.text.pdf.PdfPageEvent)`, `PdfWriter.setViewerPreferences(int)`, `getViewerPreferences()`

### getViewerPreferences

    protected int getViewerPreferences()

  Return the viewer preferences for the PDF file.

  By default returns `AllowPrinting` and `PageLayoutSinglePage`, but can be subclassed. The subclass can either have fixed preferences or retrieve them from bean properties defined on the View.

  Returns:
    an int containing the bits information against PdfWriter definitions
  See Also:
    `PdfWriter.AllowPrinting`, `PdfWriter.PageLayoutSinglePage`

### buildPdfMetadata

    protected void buildPdfMetadata(java.util.Map<java.lang.String,java.lang.Object> model,
                                    com.lowagie.text.Document document,
                                    javax.servlet.http.HttpServletRequest request)

  Populate the iText Document's meta fields (author, title, etc.).
  Default is an empty implementation. Subclasses may override this method to add meta fields such as title, subject, author, creator, keywords, etc. This method is called after assigning a PdfWriter to the Document and before calling `document.open()`.

  Parameters:
    `model` - the model, in case meta information must be populated from it
    `document` - the iText document being populated
    `request` - in case we need locale etc. Shouldn't look at attributes.
  See Also:
    `Document.addTitle(java.lang.String)`, `Document.addSubject(java.lang.String)`, `Document.addKeywords(java.lang.String)`, `Document.addAuthor(java.lang.String)`, `Document.addCreator(java.lang.String)`, `Document.addProducer()`, `Document.addCreationDate()`, `Document.addHeader(java.lang.String, java.lang.String)`

### buildPdfDocument

    protected abstract void buildPdfDocument(java.util.Map<java.lang.String,java.lang.Object> model,
                                             com.lowagie.text.Document document,
                                             com.lowagie.text.pdf.PdfWriter writer,
                                             javax.servlet.http.HttpServletRequest request,
                                             javax.servlet.http.HttpServletResponse response)
                                      throws java.lang.Exception

  Subclasses must implement this method to build an iText PDF document, given the model. Called between `Document.open()` and `Document.close()` calls.

  Note that the passed-in HTTP response is just supposed to be used for setting cookies or other HTTP headers. The built PDF document itself will automatically get written to the response after this method returns.

  Parameters:
    `model` - the model Map
    `document` - the iText Document to add elements to
    `writer` - the PdfWriter to use
    `request` - in case we need locale etc. Shouldn't look at attributes.
    `response` - in case we need to set cookies. Shouldn't write to it.
  Throws:
    `java.lang.Exception` - any exception that occured during document building
  See Also:
    `Document.open()`, `Document.close()`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD